// It's called bundle to avoid a conflict with the GO package
package bundle

import (
	"fmt"
	"os"
	"path/filepath"

	"git.badhouseplants.net/allanger/shoebill/pkg/types/metadata"
	"git.badhouseplants.net/allanger/shoebill/pkg/types/workload"
	"github.com/sirupsen/logrus"
	"gopkg.in/yaml.v2"
)

type Bundle struct {
	// A bundle's metadata
	Metadata   *metadata.Metadata `yaml:"metadata"`
	BundlePath string             `yaml:"-"`
	Workload   *workload.Workload `yaml:"-"`
}

type Image struct {
	Repository string
	Tag        string
}

// Init a new bundle struct from the file
func ReadFromFile(filePath string) (*Bundle, error) {
	var bundle Bundle
	logrus.Infof("readig the bundle file: %s", filePath)
	bundleFile, err := os.ReadFile(filePath)
	if err != nil {
		return nil, err
	}
	if err := yaml.Unmarshal(bundleFile, &bundle); err != nil {
		return nil, err
	}
	bundle.BundlePath = filepath.Dir(filePath)
	return &bundle, nil
}

func (bundle *Bundle) Bootstrap() (err error) {
	// TODO: It's ugly as hell
	workloadFilePath := fmt.Sprintf("%s/bundle/workload.yaml", bundle.BundlePath)
	bundle.Workload, err = workload.ReadFromFile(workloadFilePath)
	if err != nil {
		return
	}
	return nil
}
